/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/
* PROGRAMA	: GRIDADO
* VERSION 	: 0.8
* LUIS VASQUEZ 18082008

* 18-08-2008
* SE AGREGO A _HMG_SYSDATA[32][IDX][1] EL RECORDSET YA QUE AL TENER UNA SOLA VARIABLE PUBLICA SE PIERDE
* EL CURSOR CUANDO SE ABRE MAS DE UN RST.
* SE AGREGO A _HMG_SYSDATA[32][IDX][2] EL ARREGLO _ANEWRECORD, QUE CONTIENE UN ARRAY DE VALORES VACIOS
* PARA AGREGAR AL GRID COMO LINEA DE EOF.

*MEMVAR _HMG_SYSDATA
#include 'minigui.ch'
#include 'common.ch'

*memVar aTemp
*memvar retarray

*-----------------------------------------------------------------------------*
Function _DefineGridAdo (	ControlName	, ;
			ParentForm	, ;
			x		, ;
			y		, ;
			w		, ;
			h		, ;
			aHeaders	, ;
			aWidths		, ;
			aRows		, ;
			value		, ;
			fontname	, ;
			fontsize	, ;
			tooltip		, ;
			change		, ;
			dblclick	, ;
			aHeadClick	, ;
			gotfocus	, ;
			lostfocus	, ;
			nogrid		, ;
			aImage		, ;
			aJust		, ;
			break		, ;
			HelpId		, ;
			bold		, ;
			italic		, ;
			underline	, ;
			strikeout	, ;
			ownerdata	, ;
			ondispinfo	, ;
			itemcount	, ;
			available0	, ;
			available1	, ;
			available2	, ;
			multiselect	, ;
			available3	, ;
			backcolor	, ;
			fontcolor	, ;
			inplace		, ;
			editcontrols	, ;
			dynamicbackcolor , ;
			dynamicforecolor , ;
			columnvalid , ;
			columnwhen , ;
			columnheaders, aheaderimages )
*-----------------------------------------------------------------------------*
Local i , cParentForm , mVar, wBitmap , k := 0
Local ControlHandle
Local FontHandle
Local cParentTabName
Local Aux := {}
local _Rs, _ANEWRECORD := {}

Available1 := Nil
Available2 := Nil
Available3 := Nil

	DEFAULT INPLACE TO .F.
	DEFAULT columnheaders TO .T.

	_Rs := aRows
	
	if _HMG_SYSDATA [ 264 ] = .T.
		ParentForm := _HMG_SYSDATA [ 223 ]
		if .Not. Empty (_HMG_SYSDATA [ 224 ]) .And. ValType(FontName) == "U"
			FontName := _HMG_SYSDATA [ 224 ]
		EndIf
		if .Not. Empty (_HMG_SYSDATA [ 182 ]) .And. ValType(FontSize) == "U"
			FontSize := _HMG_SYSDATA [ 182 ]
		EndIf
	endif

	if _HMG_SYSDATA [ 183 ] > 0
		x 	:= x + _HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]]
		y 	:= y + _HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] 
		ParentForm := _HMG_SYSDATA [ 332 ] [_HMG_SYSDATA [ 183 ]]
		cParentTabName := _HMG_SYSDATA [ 225 ] 
	EndIf

	If .Not. _IsWindowDefined (ParentForm)
		MsgMiniGuiError(_HMG_SYSDATA [ 136 ][1]+ ParentForm + _HMG_SYSDATA [ 136 ][2])
	Endif

	If _IsControlDefined (ControlName,ParentForm)
		MsgMiniGuiError (_HMG_SYSDATA [ 136 ][4] + ControlName + _HMG_SYSDATA [ 136 ][5] + ParentForm + _HMG_SYSDATA [ 136 ][6])
	endif

	if ValType (aRows) = 'O'
		if aRows:Fields:Count != Len ( aHeaders )		
			aHeaders := {}
			For i:= 0 To aRows:Fields:Count -1
				aadd( aHeaders, aRows:Fields(i):Name )
			Next
		EndIf
	EndIf
	
	if ValType ( aWidths ) == 'U' .or. Len( aWidths ) = 0	
		For i:= 0 to aRows:Fields:Count-1
			aadd( aWidths, 80 )
		Next
	EndIf

	if columnheaders == .F.
		aHeaders := array ( Len ( aWidths ) )
		afill ( aHeaders , '' )
	endif

	if Len ( aHeaders ) != Len ( aWidths ) 
		aHeaders := {}
		for i:= 0 to _Rs:Fields:Count - 1
			aadd( aHeaders, _Rs:Fields(i):Name )
		Next
	EndIf

	mVar := '_' + ParentForm + '_' + ControlName

	cParentForm = ParentForm

	ParentForm = GetFormHandle (ParentForm)

	if valtype(w) == "U"
		w := 240
	endif
	if valtype(h) == "U"
		h := 120
	endif
	if valtype(value) == "U" .and. !MultiSelect
		value := 0
	endif
	
	if valtype(aJust) == "U"		// Grid+
		aJust := Array( len( aHeaders ) )
		aFill( aJust, 0 )
	else
		aSize( aJust, len( aHeaders ) )
		aEval( aJust, { |x| x := iif( x == NIL, 0, x ) } )
	endif
	if valtype(aImage) == "U"  		// Grid+
		aImage := {}
	endif

	if valtype(x) == "U" .or. valtype(y) == "U" 

		If _HMG_SYSDATA [ 216 ] == 'TOOLBAR'
			Break := .T.
		EndIf

		_HMG_SYSDATA [ 216 ]	:= 'GRID'

		i := GetFormIndex ( cParentForm )

		if i > 0 

			ControlHandle := InitListView ( _HMG_SYSDATA [ 87 ] [i] , 0, 0, 0, w, h ,'',0,iif( nogrid, 0, 1 ) , ownerdata , itemcount , multiselect , columnheaders )

			x := GetWindowCol ( Controlhandle )
			y := GetWindowRow ( Controlhandle )

			if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
				FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
			Else
				FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)		
			endif

			AddSplitBoxItem ( Controlhandle, _HMG_SYSDATA [ 87 ] [i] , w , break , , , , _HMG_SYSDATA [ 258 ] )
		EndIf

	Else

		ControlHandle := InitListView ( ParentForm, 0, x, y, w, h ,'',0, iif( nogrid, 0, 1 ) , ownerdata  , itemcount  , multiselect , columnheaders )
		if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
			FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
		Else
			FontHandle := _SetFont (ControlHandle,_HMG_SYSDATA [ 342 ],_HMG_SYSDATA [ 343 ],bold,italic,underline,strikeout)		
		endif

	endif

	If ValType (backcolor) != 'U'
		ListView_SetBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3] )
		ListView_SetTextBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3]  )
	EndIf

	If ValType (fontcolor) != 'U'
		ListView_SetTextColor ( ControlHandle , fontcolor[1] , fontcolor[2] , fontcolor[3]  )
	EndIf

	wBitmap := iif( len( aImage ) > 0, AddListViewBitmap( ControlHandle, aImage ), 0 )
	aWidths[1] := max ( aWidths[1], wBitmap + 2 ) // Set Column 1 width to Bitmap width

	If _HMG_SYSDATA [ 265 ] = .T.
		aAdd ( _HMG_SYSDATA [ 142 ] , ControlHandle )
	EndIf

	if valtype(aHeadClick) == "U"
		aHeadClick := {}
	endif

	if valtype(change) == "U"
		change := ""
	endif

	if valtype(dblclick) == "U"
		dblclick := ""
	endif

	if valtype(tooltip) != "U"
	        SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
	endif

	k := _GetControlFree()

	Public &mVar. := k

	_HMG_SYSDATA [  1 ]  [k] :=  "GRID" //if ( multiselect , "MULTIGRID" , "GRID" ) 
	_HMG_SYSDATA [  2 ]  [k] :=  ControlName 
	_HMG_SYSDATA [  3 ]  [k] :=  ControlHandle 
	_HMG_SYSDATA [  4 ]  [k] :=  ParentForm 
	_HMG_SYSDATA [  5 ]  [k] :=  0 
	_HMG_SYSDATA [  6 ]  [k] :=  ondispinfo
	_HMG_SYSDATA [  7 ]  [k] :=  aHeaders
	_HMG_SYSDATA [  8 ]  [k] :=  Value
	_HMG_SYSDATA [  9 ]  [k] :=  _ANEWRECORD
	_HMG_SYSDATA [ 10 ]  [k] :=  lostfocus 
	_HMG_SYSDATA [ 11 ]  [k] :=  gotfocus 
	_HMG_SYSDATA [ 12 ]  [k] :=  change 
	_HMG_SYSDATA [ 13 ]  [k] :=  .F. 
	_HMG_SYSDATA [ 14 ]  [k] :=  aImage 
	_HMG_SYSDATA [ 15 ]  [k] :=  Nil 
	_HMG_SYSDATA [ 16 ]  [k] :=  dblclick 
	_HMG_SYSDATA [ 17 ]  [k] :=  aHeadClick 
	_HMG_SYSDATA [ 18 ]  [k] :=  y 
	_HMG_SYSDATA [ 19 ]  [k] :=  x 
	_HMG_SYSDATA [ 20 ]  [k] :=  w 
	_HMG_SYSDATA [ 21 ]  [k] :=  h 
	_HMG_SYSDATA [ 22 ]  [k] :=  aRows
	_HMG_SYSDATA [ 23 ]  [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 24 ]  [k] :=  iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 25 ]  [k] :=  cParentForm //Nil 
	_HMG_SYSDATA [ 26 ]  [k] :=  0  
	_HMG_SYSDATA [ 27 ]  [k] :=  fontname 
	_HMG_SYSDATA [ 28 ]  [k] :=  fontsize 
	_HMG_SYSDATA [ 29 ]  [k] :=  {bold,italic,underline,strikeout} 
	_HMG_SYSDATA [ 30 ]  [k] :=  tooltip  
	_HMG_SYSDATA [ 31 ]  [k] :=  cParentTabName
	_HMG_SYSDATA [ 32 ]  [k] :=  {arows, _anewrecord}  
	_HMG_SYSDATA [ 33 ]  [k] :=  aHeaders  
	_HMG_SYSDATA [ 34 ]  [k] :=  .t. 
	_HMG_SYSDATA [ 35 ]  [k] :=  HelpId 
	_HMG_SYSDATA [ 36 ]  [k] :=  FontHandle 
	_HMG_SYSDATA [ 37 ]  [k] :=  0 
	_HMG_SYSDATA [ 38 ]  [k] :=  .T. 
	_HMG_SYSDATA [ 39 ]  [k] :=  0
	_HMG_SYSDATA [ 40 ]  [k] :=  { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

	_HMG_SYSDATA [ 40 ]  [K] [ 1 ] := inplace
	_HMG_SYSDATA [ 40 ]  [K] [ 2 ] := editcontrols
	_HMG_SYSDATA [ 40 ]  [K] [ 3 ] := dynamicbackcolor
	_HMG_SYSDATA [ 40 ]  [K] [ 4 ] := dynamicforecolor
	_HMG_SYSDATA [ 40 ]  [K] [ 5 ] := columnvalid
	_HMG_SYSDATA [ 40 ]  [K] [ 6 ] := columnwhen
	IF VALTYPE( EDITCONTROLS ) = 'A'
		FOR I:= 1 TO LEN( EDITCONTROLS )
			IF EDITCONTROLS[I,1] = 'TEXTBOX'
				IF EDITCONTROLS[I,2] = 'NUMERIC'
					AADD( _ANEWRECORD, 0)
				ELSEIF EDITCONTROLS[I,2] = 'CHARACTER'
					AADD( _ANEWRECORD, "")
				ELSEIF EDITCONTROLS[I,2] = 'DATE'
					AADD( _ANEWRECORD, CTOD('  /  /    '))
				ENDIF
			ELSEIF EDITCONTROLS[I,1] = 'SPINNER'
				AADD( _ANEWRECORD, 0)
			ELSEIF EDITCONTROLS[I,1] = 'COMBOBOX'
				AADD( _ANEWRECORD, 1)
			ELSEIF EDITCONTROLS[I,1] = 'DATEPICKER'
				AADD( _ANEWRECORD, CTOD('  /  /    '))
				*AADD( _ANEWRECORD, DATE())
			ELSEIF EDITCONTROLS[I,1] = 'CHECKBOX'
				AADD( _ANEWRECORD, .T.)
			ENDIF
		NEXT I
	ELSE
		FOR I:= 0 TO _RS:FIELDS:COUNT -1
			AADD( _ANEWRECORD, "" )
		NEXT I
	ENDIF
	_HMG_SYSDATA [  9 ]  [k] :=  _ANEWRECORD

	InitListViewColumns ( ControlHandle, aHeaders , aWidths, aJust )


	IF _RS:RECORDCOUNT > 0
		FOR I:= 1 TO _RS:RECORDCOUNT
			AUX := {}			
			FOR J := 0 TO _RS:FIELDS:COUNT() - 1
				IF _RS:FIELDS(J):ACTUALSIZE > 0
					AADD( AUX, _RS:FIELDS(J):VALUE )
				ELSE
					AADD( AUX, _EMPTYFIELD(J,_rs) )
				ENDIF
			NEXT J
			_RS:MOVENEXT()
    	    _ADDGRIDROW ( CONTROLNAME, CPARENTFORM, AUX )
		NEXT I
		_RS:MOVEFIRST()
	ENDIF
	
	_ADDGRIDROW( CONTROLNAME, CPARENTFORM, _ANEWRECORD )
	
	
	if multiselect == .T.

		if VALTYPE ( value ) == 'A'
			ListViewSetMultiSel (ControlHandle,value)
		endif

	Else

		if value <> 0 
			ListView_SetCursel (ControlHandle ,value)
		endif

	EndIf
	
	If ValType(aHeaderImages) <> "U"
		nHeaderImageListHandle := SetListViewHeaderImages ( ControlHandle , aHeaderImages , aJust )
		_HMG_SYSDATA [ 22 ] [k] := aHeaderImages
		_HMG_SYSDATA [ 26 ] [k] := nHeaderImageListHandle
	EndIf
	

	_HMG_DOGRIDREFRESH(K)

Return Nil
*-----------------------------------------------------------------------------*
Function _AddGridRow ( ControlName, ParentForm, aRow )
*-----------------------------------------------------------------------------*
Local h, i, iIm := 0 , x 

LOCAL ATEMP := {}

	i := GetControlIndex ( ControlName , ParentForm )

	if Len ( _HMG_SYSDATA [  7 ] [i] )  != Len ( aRow )
		MsgMiniGuiError ("Grid.AddItem: Item size mismatch. Program Terminated")
	EndIf

        h := GetControlHandle ( ControlName, ParentForm )

	IF VALTYPE ( _HMG_SYSDATA [40] [I] [2] ) == 'A'

		ATEMP := ARRAY ( LEN (AROW) )
		AFILL ( ATEMP , '' )

		if  len( _HMG_SYSDATA [ 14 ][i] ) > 0
			iIm 	:= aRow[1]
			aRow[1] := NIL
			aTemp[1] := NIL
		endif	

		AddListViewItems ( h , aTemp , iIm )

		_SetItem ( ControlName , ParentForm , LISTVIEWGETITEMCOUNT(H) , aRow )

	ELSE

		if  len( _HMG_SYSDATA [ 14 ][i] ) > 0
			iIm 	:= aRow[1]
			aRow[1] := NIL
		endif	

		AddListViewItems ( h , aRow, iIm )

		_HMG_DOGRIDREFRESH(I)

	ENDIF

Return Nil

*------------------------------------------------------------------------------*
Procedure _AddGridColumn ( cControlName , cParentForm , nColIndex , cCaption , nWidth , nJustify )
*------------------------------------------------------------------------------*
Local i , x  , atemp := {}

	// Get Control Index

	i := GetControlIndex ( cControlName , cParentForm )

	// Set Default Values

	If ValType ( nColIndex ) == 'U'
		nColIndex := Len ( _HMG_SYSDATA [  7 ] [i] ) + 1
	EndIf

	If ValType ( cCaption ) == 'U'
		cCaption := ''
	EndIf

	If ValType ( nWidth ) == 'U'
		nWidth := 120
	EndIf

	If ValType ( nJustify ) == 'U'
		nJustify := 0
	EndIf

	// Update Grid Object

	For x := 1 To nColIndex - 1
		aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x] )
	Next x

	aadd ( atemp , cCaption )

	For x := nColIndex + 1 To Len ( _HMG_SYSDATA [  7 ] [i] ) + 1
		aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x-1] )
	Next x

	_HMG_SYSDATA [  7 ] [i] := atemp
	_HMG_SYSDATA [ 33 ] [i] := atemp

	// Call C-Level Routine

	ListView_AddColumn( _HMG_SYSDATA [3][i] , nColIndex , nWidth , cCaption , nJustify )

Return

*------------------------------------------------------------------------------*
Procedure _DeleteGridColumn ( cControlName , cParentForm , nColIndex )
*------------------------------------------------------------------------------*
Local i , x  , atemp := {}

	// Get Control Index

	i := GetControlIndex ( cControlName , cParentForm )

	// Update Grid Object

	For x := 1 To nColIndex - 1 
		aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x] )
	Next x

	For x := nColIndex + 1 To Len ( _HMG_SYSDATA [  7 ] [i] ) 
		aadd ( atemp , _HMG_SYSDATA [  7 ] [i] [x] )
	Next x

	_HMG_SYSDATA [  7 ] [i] := atemp
	_HMG_SYSDATA [ 33 ] [i] := atemp

	// Call C-Level Routine

	ListView_DeleteColumn ( _HMG_SYSDATA [3][i] , nColIndex )

Return

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_GRIDINPLACEEDIT(IDX)
*-----------------------------------------------------------------------------*
Local r , c , h , i , aTemp , ri , ci , X , DW := 0, DH := 0 , DR := 0 , DC := 0
LOCAL AEDITCONTROLS
LOCAL AEC := 'TEXTBOX' 
LOCAL AITEMS := {}
LOCAL ARANGE := {}
LOCAL DTYPE := 'D'
LOCAL ALABELS := { '.T.' ,'.F.' }
LOCAL CTYPE := 'CHARACTER'
LOCAL CINPUTMASK := ''
LOCAL CFORMAT := ''
LOCAL XRES := {}
LOCAL CVA 
LOCAL CWH
LOCAL VALID
LOCAL WHEN
LOCAL GFN 
LOCAL GFS 
LOCAL V

	If This.CellRowIndex != LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [ idx ] )
		Return 
	EndIf

	ri := This.CellRowIndex
	ci := This.CellColIndex

	if ri == 0 .or. ci == 0
		return
	endif
	
	GFN := _HMG_SYSDATA [ 27 ] [idx]
	GFS := _HMG_SYSDATA [ 28 ] [idx]

	aTemp := this.item(ri)

	v := aTemp [ci]

	CWH := 	_HMG_SYSDATA [40] [IDX] [6]

	IF VALTYPE ( CWH ) = 'A'

		IF LEN ( CWH ) >= CI

			IF VALTYPE ( CWH [CI] ) = 'B'

				_HMG_SYSDATA [ 318 ] := V

				WHEN := EVAL ( CWH [CI] )

				IF WHEN = .F.
					_HMG_SYSDATA [ 256 ] := .F.
					RETURN
				ENDIF

			ENDIF

		ENDIF	

	ENDIF

	h := _HMG_SYSDATA [3] [IDX]

	r := This.CellRow + GetWindowRow ( h ) - This.Row - 1

	if _HMG_SYSDATA [ 23 ]  [idx] <> -1
		r := r - _HMG_SYSDATA [ 23 ] [idx]
	endif

	c := This.CellCol + GetWindowCol ( h ) - This.Col + 2

	if _HMG_SYSDATA [ 24 ] [idx] <> -1
		c := c - _HMG_SYSDATA [ 24 ] [idx]
	endif

	AEDITCONTROLS := _HMG_SYSDATA [ 40 ] [ IDX ] [ 2 ]

	CVA := 	_HMG_SYSDATA [ 40 ] [ IDX ] [ 5 ]

	XRES := _HMG_PARSEGRIDCONTROLS ( AEDITCONTROLS , CI )

	AEC		:= XRES [1]	
	CTYPE		:= XRES [2]	
	CINPUTMASK	:= XRES [3]	
	CFORMAT		:= XRES [4]	
	AITEMS		:= XRES [5]	
	ARANGE		:= XRES [6]	
	DTYPE		:= XRES [7]	
	ALABELS		:= XRES [8]	

	IF AEC = 'COMBOBOX'
		DH := 1
	ELSEIF AEC = 'CHECKBOX'
		DR := 3
		DH := -7
	ENDIF

	_HMG_SYSDATA [ 109 ] := GetActiveWIndow()

	DEFINE WINDOW _hmg_grid_inplaceedit AT r + DR , c + DC ;
		WIDTH This.CellWidth +  DW ;
		HEIGHT This.CellHeight + 6 + DH ;
		TITLE '' MODAL ;
		NOSIZE ;
		NOCAPTION

		ON KEY ESCAPE OF W ACTION ( _HMG_SYSDATA [ 256 ] := .T. , THISWINDOW.RELEASE )
		ON KEY RETURN OF W ACTION IF ( _ISWINDOWACTIVE ( '_hmg_grid_inplaceedit' ) , ( _HMG_SYSDATA [ 256 ] := .F. , _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , ATEMP , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA ) ) , NIL )

		IF AEC == 'TEXTBOX' 

			DEFINE TEXTBOX T
				FONTNAME	GFN
				FONTSIZE	GFS

				ROW	0
				COL	0
				WIDTH 	This.CellWidth
				HEIGHT	This.CellHeight + 6

				IF CTYPE == 'NUMERIC'
					NUMERIC .T.
				ELSEIF CTYPE == 'DATE'
					DATE .T.
				ENDIF

				VALUE	v

				IF ! EMPTY ( CINPUTMASK )
					INPUTMASK CINPUTMASK
				ENDIF

				IF ! EMPTY ( CFORMAT )
					FORMAT CFORMAT
				ENDIF

			END TEXTBOX

		ELSEIF AEC == 'DATEPICKER'

			DEFINE DATEPICKER D
				FONTNAME	GFN
				FONTSIZE	GFS
				ROW	0
				COL	0
				WIDTH 	This.CellWidth 
				HEIGHT	This.CellHeight + 6 
				VALUE	V

				IF DTYPE = 'DROPDOWN'
					UPDOWN .F.
				ELSEIF DTYPE = 'UPDOWN'
					UPDOWN .T.
				ENDIF

			END DATEPICKER

		ELSEIF AEC == 'COMBOBOX'

			DEFINE COMBOBOX C
				FONTNAME	GFN
				FONTSIZE	GFS

				ROW	0
				COL	0
				WIDTH 	This.CellWidth
				ITEMS	AITEMS
				VALUE	v
			END COMBOBOX

		ELSEIF AEC == 'SPINNER'

			DEFINE SPINNER S
				FONTNAME	GFN
				FONTSIZE	GFS

				ROW		0
				COL		0
				WIDTH 		This.CellWidth
				HEIGHT		This.CellHeight + 6
				VALUE		V
				RANGEMIN	ARANGE [1]
				RANGEMAX	ARANGE [2]
			END SPINNER

		ELSEIF AEC == 'CHECKBOX'

			DEFINE CHECKBOX C
				FONTNAME	GFN
				FONTSIZE	GFS

				ROW		0
				COL		0
				WIDTH 		This.CellWidth + DW 
				HEIGHT		This.CellHeight + 6 + DH
				VALUE		V
		
				IF V == .T.
					CAPTION ALABELS [1]
				ELSEIF V == .F.
					CAPTION ALABELS [2]
				ENDIF

				BACKCOLOR WHITE
				ONCHANGE IF ( THIS.VALUE == .T. , THIS.CAPTION := ALABELS [1] , THIS.CAPTION := ALABELS [2] )
			END CHECKBOX

		ENDIF

	END WINDOW

	ACTIVATE WINDOW _hmg_grid_inplaceedit

	_HMG_SYSDATA [ 109 ] := 0

RETURN

*-----------------------------------------------------------------------------*
FUNCTION _HMG_PARSEGRIDCONTROLS ( AEDITCONTROLS , CI )
*-----------------------------------------------------------------------------*
LOCAL AEC := 'TEXTBOX' 
LOCAL AITEMS := {}
LOCAL ARANGE := {}
LOCAL DTYPE := 'D'
LOCAL ALABELS := { '.T.' ,'.F.' }
LOCAL CTYPE := 'CHARACTER'
LOCAL CINPUTMASK := ''
LOCAL CFORMAT := ''
LOCAL ARET := {}
LOCAL DW , DH , DR , DC

	IF VALTYPE ( AEDITCONTROLS ) = 'A'

		IF LEN ( AEDITCONTROLS ) >= ci

			IF VALTYPE ( AEDITCONTROLS [CI] ) = 'A'

				IF LEN ( AEDITCONTROLS [CI] ) >= 1

					AEC := AEDITCONTROLS [CI] [1]

					IF LEN ( AEDITCONTROLS [CI] ) >= 2 ;
						.AND. ;
						AEC == 'TEXTBOX'

						IF VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'C'
							CTYPE := AEDITCONTROLS [CI] [2]
						ENDIF

						IF LEN ( AEDITCONTROLS [CI] ) >= 3
							IF VALTYPE ( AEDITCONTROLS [CI] [3] ) = 'C'
								CINPUTMASK := AEDITCONTROLS [CI] [3]
							ENDIF
						ENDIF

						IF LEN ( AEDITCONTROLS [CI] ) >= 4
							IF VALTYPE ( AEDITCONTROLS [CI] [4] ) = 'C'
								CFORMAT := AEDITCONTROLS [CI] [4]
							ENDIF
						ENDIF

					ENDIF

					IF LEN ( AEDITCONTROLS [CI] ) >= 2 ;
						.AND. ;
						AEC == 'COMBOBOX'
						IF VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'A'
							AITEMS := AEDITCONTROLS [CI] [2]
						ENDIF
					ENDIF

					IF LEN ( AEDITCONTROLS [CI] ) == 3 ;
						.AND. ;
						AEC == 'SPINNER'
						IF	VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'N' ;
							.AND. ;
							VALTYPE ( AEDITCONTROLS [CI] [3] ) = 'N'
								ARANGE := { AEDITCONTROLS [CI] [2] , AEDITCONTROLS [CI] [3] }
						ENDIF
					ENDIF

					IF LEN ( AEDITCONTROLS [CI] ) >= 2 ;
						.AND. ;
						AEC == 'DATEPICKER'
						IF 	VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'C' 
							DTYPE := AEDITCONTROLS [CI] [2]
						ENDIF

					ENDIF

					IF LEN ( AEDITCONTROLS [CI] ) == 3 ;
						.AND. ;
						AEC == 'CHECKBOX'
						DW := -4
						DH := -7
						DR := 3
						DC := 2
						IF 	VALTYPE ( AEDITCONTROLS [CI] [2] ) = 'C' ;
							.AND. ;
							VALTYPE ( AEDITCONTROLS [CI] [3] ) = 'C' 
							ALABELS := { AEDITCONTROLS [CI] [2] , AEDITCONTROLS [CI] [3] }
						ENDIF
					ENDIF

				ENDIF

			ENDIF

		ENDIF

	ENDIF

	ARET := { AEC , CTYPE , CINPUTMASK , CFORMAT , AITEMS , ARANGE , DTYPE , ALABELS }

RETURN ( ARET )

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_GRIDINPLACEEDITOK ( IDX , CI , RI , ATEMP , AEC , ALABELS , CTYPE , CINPUTMASK , CFORMAT , CVA )
*-----------------------------------------------------------------------------*
LOCAL BD 
LOCAL VALID

	IF VALTYPE ( CVA ) = 'A'

		IF LEN ( CVA ) >= CI

			IF VALTYPE ( CVA [CI] ) = 'B'

				IF	AEC == 'TEXTBOX'
					// _HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.t.value 
					_HMG_SYSDATA [ 318 ] := GetProperty ( "_hmg_grid_inplaceedit","t","value")
				ELSEIF	AEC == 'DATEPICKER'
					_HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.d.value
				ELSEIF	AEC == 'COMBOBOX'
					_HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.c.value 
				ELSEIF	AEC == 'SPINNER'
					_HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.s.value
				ELSEIF	AEC == 'CHECKBOX'
					_HMG_SYSDATA [ 318 ] := _hmg_grid_inplaceedit.c.value
				ENDIF

				VALID := EVAL ( CVA [CI] )

				IF VALID = .F.

					MSGEXCLAMATION ( _HMG_SYSDATA [ 136 ][11] )
					RETURN

				ENDIF

			ENDIF

		ENDIF	

	ENDIF

	IF	AEC == 'TEXTBOX'
		// aTemp [ci] := _hmg_grid_inplaceedit.t.value 
		aTemp [ci] := GetProperty ( "_hmg_grid_inplaceedit","t","value")
	ELSEIF	AEC == 'DATEPICKER'
		aTemp [ci] := _hmg_grid_inplaceedit.d.value
	ELSEIF	AEC == 'COMBOBOX'
		aTemp [ci] := _hmg_grid_inplaceedit.c.value 
	ELSEIF	AEC == 'SPINNER'
		aTemp [ci] := _hmg_grid_inplaceedit.s.value
	ELSEIF	AEC == 'CHECKBOX'
		aTemp [ci] := _hmg_grid_inplaceedit.c.value
	ENDIF
		
	_SetItem ( , , ri , aTemp , idx )

	_hmg_grid_inplaceedit.RELEASE
	
	_HMG_SETGRIDCELLVALUE( _HMG_SYSDATA[2][IDX], _HMG_SYSDATA [25][IDX], ri, ci, aTemp[ci] )
RETURN
*-----------------------------------------------------------------------------*
PROCEDURE _HMG_GRIDINPLACEKBDEDIT(i)
*-----------------------------------------------------------------------------*
LOCAL TmpRow
LOCAL XS
LOCAL XD
LOCAL R
LOCAL IPE_MAXCOL

	IPE_MAXCOL := Len ( _HMG_SYSDATA [ 33 ] [i] )
	
	Do While .T.

		TmpRow := LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA [3] [i] )

		If TmpRow != _HMG_SYSDATA [ 341 ] 

			_HMG_SYSDATA [ 341 ] := TmpRow

			if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0 
				_HMG_SYSDATA [ 340 ] := 2
			Else
				_HMG_SYSDATA [ 340 ] := 1
			EndIf

		EndIf

		_HMG_SYSDATA [ 195 ] := _HMG_SYSDATA [ 341 ]
		_HMG_SYSDATA [ 196 ] := _HMG_SYSDATA [ 340 ]

		If _HMG_SYSDATA [ 340 ] == 1
			r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 )
		Else
			r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 , _HMG_SYSDATA [ 340 ] - 1 )
		EndIf

		xs :=	( ( _HMG_SYSDATA [ 19 ] [i] + r [2] ) +( r[3] ))  -  ( _HMG_SYSDATA [ 19 ] [i] + _HMG_SYSDATA [ 20 ] [i] )

		xd := 20

		If xs > -xd 
			ListView_Scroll( _HMG_SYSDATA [3] [i] ,	xs + xd , 0 ) 
		Else

        		If r [2] < 0
                	     ListView_Scroll( _HMG_SYSDATA [3] [i] , r[2]	, 0 )
	            EndIf

		endIf

		If _HMG_SYSDATA [ 340 ] == 1
			r := LISTVIEW_GETITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 )
		Else
			r := LISTVIEW_GETSUBITEMRECT ( _HMG_SYSDATA [3] [i]  , _HMG_SYSDATA [ 341 ] - 1 , _HMG_SYSDATA [ 340 ] - 1 )
		EndIf

		_HMG_SYSDATA [ 197 ] := _HMG_SYSDATA [ 18 ] [i] + r [1]
		_HMG_SYSDATA [ 198 ] := _HMG_SYSDATA [ 19 ] [i] + r [2]
		_HMG_SYSDATA [ 199 ] := r[3]
		_HMG_SYSDATA [ 200 ] := r[4]

		*
		_HMG_SYSDATA [ 194 ] := ascan ( _HMG_SYSDATA [ 67  ] , _HMG_SYSDATA [4][i] )
		_HMG_SYSDATA [ 231 ] := 'C'
		_HMG_SYSDATA [ 203 ] := i
		_HMG_SYSDATA [ 316 ] :=  _HMG_SYSDATA [  66 ] [ _HMG_SYSDATA [ 194 ] ]  
		_HMG_SYSDATA [ 317 ] :=  _HMG_SYSDATA [2] [_HMG_SYSDATA [ 203 ]]
		*

		_HMG_GRIDINPLACEEDIT(I)

		_HMG_SYSDATA [ 203 ] := 0
		_HMG_SYSDATA [ 231 ] := ''

		_HMG_SYSDATA [ 195 ] := 0
		_HMG_SYSDATA [ 196 ] := 0
		_HMG_SYSDATA [ 197 ] := 0
		_HMG_SYSDATA [ 198 ] := 0
		_HMG_SYSDATA [ 199 ] := 0
		_HMG_SYSDATA [ 200 ] := 0

		*
		_HMG_SYSDATA [ 194 ] := 0
		_HMG_SYSDATA [ 232 ] := ''
		_HMG_SYSDATA [ 316 ] :=  ''
		_HMG_SYSDATA [ 317 ] := ''
		*

		If _HMG_SYSDATA [ 256 ] == .T.

			If _HMG_SYSDATA [ 340 ] == IPE_MAXCOL

				if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0 
					_HMG_SYSDATA [ 340 ] := 2
				Else
					_HMG_SYSDATA [ 340 ] := 1
				EndIf

				ListView_Scroll( _HMG_SYSDATA [3] [i] ,	-10000  , 0 ) 
			EndIf

			Exit

		Else

			_HMG_SYSDATA [ 340 ]++

			If _HMG_SYSDATA [ 340 ] > IPE_MAXCOL

				if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0 
					_HMG_SYSDATA [ 340 ] := 2
				Else
					_HMG_SYSDATA [ 340 ] := 1
				EndIf

				ListView_Scroll( _HMG_SYSDATA [3] [i] ,	-10000  , 0 ) 
				Exit
			EndIf

		EndIf		

	EndDo

RETURN
*------------------------------------------------------------------------------*
Function GetNumFromCellText ( Text )
*------------------------------------------------------------------------------*
Local x , c , s

	s := ''

	For x := 1 To Len ( Text )
		
		c := SubStr(Text,x,1)

		If c='0' .or. c='1' .or. c='2' .or. c='3' .or. c='4' .or. c='5' .or. c='6' .or. c='7' .or. c='8' .or. c='9' .or. c='.' .or. c='-'
			s := s + c
		EndIf

	Next x

	If Left ( AllTrim(Text) , 1 ) == '(' .OR.  Right ( AllTrim(Text) , 2 ) == 'DB'
		s := '-' + s
	EndIf

Return Val(s)

*------------------------------------------------------------------------------*
Function GETNumFromCellTextSP(Text)
*------------------------------------------------------------------------------*
Local x , c , s

	s := ''

	For x := 1 To Len ( Text )
 
		c := SubStr(Text,x,1)

		If c='0' .or. c='1' .or. c='2' .or. c='3' .or. c='4' .or. c='5' .or. c='6' .or. c='7' .or. c='8' .or. c='9' .or. c=',' .or. c='-' .or. c = '.'

			if c == '.'
				c :=''
			endif  
 
			IF C == ','
				C:= '.'
			ENDIF

			s := s + c

		EndIf

	Next x

	If Left ( AllTrim(Text) , 1 ) == '(' .OR.  Right ( AllTrim(Text) , 2 ) == 'DB'
		s := '-' + s
	EndIf

Return Val(s)
*------------------------------------------------------------------------------*
FUNCTION _HMG_GETGRIDCELLVALUE ( CONTROLNAME , PARENTFORM , ROW , COL )
*------------------------------------------------------------------------------*
	LOCAL A
	LOCAL V
	LOCAL i := GetControlIndex( CONTROLNAME, PARENTFORM )
	LOCAL _Rs
	
	_Rs = _HMG_SYSDATA[32][I][1]
	
	IF GetProperty( PARENTFORM, CONTROLNAME, 'VALUE' ) > 0
		if _Rs:Recordcount > 0 .and. ROW-1 <= _Rs:RecordCount
			_Rs:MoveFirst()
			_Rs:Move( ROW - 1 )
			V = _Rs:Fields(COL-1):Value
		Else
			A := _GetItem ( CONTROLNAME , PARENTFORM , ROW  )
			V := A [ COL ]
		Endif
	ELSE
		MsgMiniGuiError('Not Select Row '+Controlname)
	ENDIF

RETURN V
*------------------------------------------------------------------------------*
PROCEDURE _HMG_SETGRIDCELLVALUE ( CONTROLNAME , PARENTFORM , ROW , COL , CELLVALUE )
*------------------------------------------------------------------------------*
	LOCAL A, R := ROW
	LOCAL i := GetControlIndex( CONTROLNAME, PARENTFORM )
	LOCAL _Rs, _aNEWRECORD
	
	_Rs 		= _HMG_SYSDATA[32][I][1]
	_ANEWRECORD = _HMG_SYSDATA[32][I][2]
	*--- LVP
	// ACTUALIZO EL RECORDSET
	IF ROW > _Rs:Recordcount
		_Rs:AddNew()
	ELSE
		_Rs:MoveFirst()
		_Rs:Move( ROW-1 )
	ENDIF
	
	IF VALTYPE(_ANEWRECORD[COL] ) = 'L'
		_Rs:Fields(COL-1):Value := IF( CELLVALUE, 0, -1 )
	ELSEIF VALTYPE(_ANEWRECORD[COL]) = 'D'
		IF VALTYPE( CELLVALUE ) = 'C'			
			_Rs:Fields(COL-1):Value := IF( DAY(CTOD(CELLVALUE)) = 0, DATE(), CTOD(CELLVALUE) )
		ELSE
			_Rs:Fields(COL-1):Value := IF( DAY(CELLVALUE) = 0, DATE(), CELLVALUE )
		ENDIF			
	ELSE
		_Rs:Fields(COL-1):Value := CELLVALUE
	ENDIF
		
	_Rs:Update()
	// SE DEBE REFRESCAR EL QUERY Y VOLVER A UBICAR EL PUNTERO EN LA LINEA QUE CORRESPONDE
	_Rs:Requery()
	_Rs:MoveFirst()
	_Rs:Move( ROW-1 )
	
	// ACTUALIZA EL GRID
	A 	:= _GetItem ( CONTROLNAME , PARENTFORM , ROW  )
	FOR i:= 1 TO Col-1
		A[i] := _Rs:Fields(i-1):Value
	NEXT
	A [ COL ] 	:= CELLVALUE

	_SetItem ( CONTROLNAME , PARENTFORM , ROW , A )
	*--- LVP 
	// AGREGA LA FILA DE EOF.
	IF GetProperty( PARENTFORM, CONTROLNAME, "ITEMCOUNT") == _Rs:RecordCount
		_AddGridRow( ControlName, ParentForm, _ANEWRECORD )
		SETPROPERTY( PARENTFORM, CONTROLNAME,'VALUE', R )
	ENDIF
RETURN

*-----------------------------------------------------------------------------*
PROCEDURE _HMG_DOGRIDREFRESH(I)
*-----------------------------------------------------------------------------*
LOCAL dbc , dfc , processdbc , processdFc , COLS , ROWS , R , C , TEVAL , V 
LOCAL ATEMP
LOCAL AVALUES

	dbc := 	_HMG_SYSDATA [ 40 ] [I] [3]
	processdbc := if ( valtype (dbc) = 'A' , .t. , .f. )

	dfc := 	_HMG_SYSDATA [ 40 ] [I] [4]
	processdFc := if ( valtype (dFc) = 'A' , .t. , .f. )

	IF processdbc == .F. .AND. processdFc == .F.
		RETURN
	ELSE		

	ENDIF

	Rows := LISTVIEWGETITEMCOUNT ( _HMG_SYSDATA [3] [i] )

	Cols := Len ( _HMG_SYSDATA [  7 ] [i] )

	ATEMP := ARRAY ( Rows , Cols )

	IF processdbc == .T.
		
		FOR R := 1 TO ROWS

			aValues := _GetItem ( , , R , i )

			FOR C := 1 TO COLS

				aTemp [R] [C] := -1

				_HMG_SYSDATA [ 195 ] := R
				_HMG_SYSDATA [ 196 ] := C

				_HMG_SYSDATA [ 318 ] := aValues [c]

				tEval := eval ( dbc [c] )

				IF VALTYPE ( TEVAL ) == 'A'
					IF LEN ( TEVAL ) == 3
						TEVAL := RGB ( TEVAL [1] , TEVAL [2] , TEVAL [3] )
						IF VALTYPE (TEVAL) = 'N'
							aTemp [R] [C] := tEval 
						ENDIF
					ENDIF
				ENDIF

			NEXT C

		NEXT R

		*__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_SYSDATA [3][i])) + '_' + 'DATA_01' , aTemp )

		_HMG_SYSDATA [40] [I] [7] := aTemp

	ELSE

		*__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_SYSDATA [3][i])) + '_' + 'DATA_01' , Nil )

		_HMG_SYSDATA [40] [I] [7] := Nil

	ENDIF

	IF processdfc == .T.

		ATEMP := ARRAY ( Rows , Cols )

		FOR R := 1 TO ROWS

			aValues := _GetItem ( , , R , i )

			FOR C := 1 TO COLS

				aTemp [R] [C] := -1

				_HMG_SYSDATA [ 195 ] := R
				_HMG_SYSDATA [ 196 ] := C

				_HMG_SYSDATA [ 318 ] := aValues [c]

				tEval := eval ( dfc [c] )

				IF VALTYPE ( TEVAL ) == 'A'
					IF LEN ( TEVAL ) == 3
						TEVAL := RGB ( TEVAL [1] , TEVAL [2] , TEVAL [3] )
						IF VALTYPE (TEVAL) = 'N'
							aTemp [R] [C] := tEval 
						ENDIF
					ENDIF
				ENDIF

			NEXT C

		NEXT R

		*__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_SYSDATA [3][i])) + '_' + 'DATA_02' , aTemp )
		_HMG_SYSDATA [40] [I] [8] := aTemp

	ELSE

		*__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_SYSDATA [3][i])) + '_' + 'DATA_02' , Nil )
		_HMG_SYSDATA [40] [I] [8] := Nil

	ENDIF

	RedrawWindow ( _HMG_SYSDATA [3] [i] )

RETURN
*--	LVP
*- RETURN THE FIELD TYPE 
FUNCTION _TypeFields( i, _rs )
	local xValue				
	
	do case                                                                                  		
	case _Rs:fields(i):Type >= 2 .and. _Rs:fields(i):Type <= 6 // numero         
		xValue = 'N'                                                                        
	case _Rs:fields(i):Type = 7	//fecha                                               
		xValue = 'D'
	case _Rs:fields(i):Type = 11 .and.  _Rs:fields(i):Type = 12 // bool                                              
		xValue = 'L'                                                                         
	case _Rs:fields(i):Type =129 .and. _Rs:fields(i):Type = 130 // texto o memo
		xValue = "C"                                                                        
	case _Rs:fields(i):Type =202 
		xValue = "C"                                                                        
	otherwise        
		xValue = "U"                                                                         
	endcase              

RETURN xValue

FUNCTION _EmptyField(i,_rs)
	Local xValue, xResp
	
	xValue = _TypeFields(i,_rs)
	
	DO CASE
	CASE xValue = 'D'
		xResp = Date()
	CASE xValue = 'N'
		xResp = 0
	CASE xValue = 'L'
		xResp = .T.
	CASE xValue = 'C' .or. xValue = 'M'
		xResp = ""
	CASE xValue = 'U'
		xResp = "Undefined"
	CASE xValue = NIL
		xResp = "Nil"
	ENDCASE
	
RETURN xResp

// RECARGA UN GRID
PROCEDURE LoadData(Parentform, Controlname)
	Local Aux 	:= {}
	LOCAL i 	:= GetControlIndex( CONTROLNAME, PARENTFORM ), j := 0
	LOCAL _Rs, _ANEWRECORD
	
	_Rs 		= _HMG_SYSDATA[32][I][1]
	_ANEWRECORD = _HMG_SYSDATA[32][I][2]

	IF _RS:RECORDCOUNT > 0
		_RS:MOVEFIRST()
		WHILE !_RS:EOF()
			AUX := {}
			FOR J = 0 TO _RS:FIELDS:COUNT() - 1
				AADD( AUX, _RS:FIELDS(J):VALUE )
			NEXT
			_RS:MOVENEXT()
    	    _ADDGRIDROW ( CONTROLNAME, PARENTFORM, AUX )
		ENDDO

		_RS:MOVEFIRST()
		
	ENDIF
		
	_ADDGRIDROW( CONTROLNAME, PARENTFORM, _ANEWRECORD )
			
RETURN

// BORRA LINEA DEL GRID
PROCEDURE _DelRow(ParentForm, ControlName, nRow)
	LOCAL i := GetControlIndex( CONTROLNAME, PARENTFORM )
	LOCAL _Rs
	
	_Rs = _HMG_SYSDATA[32][I][1]

	IF _RS:RECORDCOUNT > 0
		_RS:MOVEFIRST()
		_RS:MOVE( NROW-1 )
		_RS:DELETE()
		
		_DELETEITEM( CONTROLNAME, PARENTFORM, NROW )

		IF NROW > GETPROPERTY(PARENTFORM,CONTROLNAME,"ITEMCOUNT")
			NROW = GETPROPERTY(PARENTFORM,CONTROLNAME,"ITEMCOUNT")
		ENDIF
		
		SETPROPERTY( PARENTFORM, CONTROLNAME, "VALUE", NROW )
	ENDIF
	
RETURN