/*
* MiniGUI GridAdo Demo
* Read/write data in table.
* Luis Vasquez 2008
*/

#include "minigui.ch"
#include "i_xgrid.ch"
#include 'adodb.ch'


set procedure to h_xgrid.prg

Function Main
	Local oConn, oRs
	local aHeaders := {'First','Last','Born','Married','Calculate'} 
    local aImages  := { '02.bmp' , '00.bmp' , '00.bmp', '00.bmp' , '00.bmp' }

	SET DATE BRITISH
	SET CENTURY ON
		
	oConn := TOleauto():new('ADODB.Connection')
	oConn:ConnectionString:= "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=bd1.mdb;User Id=admin;"
	oConn:Open()
	
	oRs = TOleauto():New('ADODB.Recordset')
	oRs:CursorLocation= adUseClient
	oRs:Open( "SELECT FIRST, LAST, HIREDATE, MARRIED, [SALARY]*[AGE] FROM Customer", oConn, adOpenDynamic, adLockOptimistic )
	
	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 640 ;
		HEIGHT 400 ;
		TITLE 'Mixed Data Type Grid Test' ;
		MAIN ;
		ON PAINT ( ajustar() );
		ON RELEASE (oRs:close, oConn:close() )


		DEFINE MAIN MENU
			DEFINE POPUP 'File'
				MENUITEM "Exit" ACTION ( Form_1.release )
			END POPUP
			DEFINE POPUP "Edit"
				MENUITEM 'Get Item'	ACTION GetItem(oRs)
				SEPARATOR
				MENUITEM 'Delete Item'	ACTION Del(oRs)
			END POPUP
		END MENU
		
		DEFINE LABEL LABEL_1
			ROW 	0
			COL 	5
			WIDTH 	80
			HEIGHT 	20
			VALUE 	"Filter:"
		END LABEL

		DEFINE COMBOBOX COMBO_1
			ROW 	0
			COL 	90
			WIDTH 	100
			HEIGHT 	100
			ITEMS 	{"Remove filter", 'First','Last'}		
			VALUE 	1
		END COMBOBOX
		
		DEFINE TEXTBOX TEXT_1
			ROW 	0
			COL 	200
			WIDTH 	100
			HEIGHT 	20
			VALUE 	""
		END TEXTBOX
		
		DEFINE BUTTON BTN_3
			ROW 	0
			COL 	310
			WIDTH 	80
			HEIGHT 	20
			CAPTION "Filtro"
			ACTION 	Filtro(oRs)
		END BUTTON
				
		@ 25,10 GRIDADO Grid_1 ;
			WIDTH 	620 ;
			HEIGHT 	330 ;
			HEADERS aheaders ;
			WIDTHS 	{100, 100, 100, 100, 100 } ;
			RECORDSET oRs ;
			VALUE 1;
			EDIT 		;
			COLUMNCONTROLS {{'TEXTBOX','CHARACTER'}, ;
							{'TEXTBOX','CHARACTER'}, ;
							{'TEXTBOX','DATE'}, ;
							{'CHECKBOX','Yes','No'}, ;
							{'TEXTBOX','NUMERIC','999,999,999'}  } ;
			COLUMNWHEN	{ { || .T. }, { || .T. }, { || .T. }, { || .T. }, { || .f. } };
			COLUMNVALID { { || .T. }, { || .T.}, { || .T. }, { || .T. }, { || .f. } };
			JUSTIFY { 0, 0, 2, 0, 1 };
			HEADERIMAGES aImages

	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return

PROCEDURE GETITEM(oRs)
	local a
	IF FORM_1.GRID_1.VALUE > 0
		a = "First = "+form_1.grid_1.cell( form_1.grid_1.value, 1)+hb_osnewline()+;
			"Last  = "+form_1.grid_1.cell( form_1.grid_1.value, 2)+hb_osnewline()+;
			"Date  = "+dtoc(form_1.grid_1.cell( form_1.grid_1.value, 3))+hb_osnewline()+;
			"Married="+if(form_1.grid_1.cell( form_1.grid_1.value, 4), 'Yes','No')
    	
		Msginfo( a )	
	ENDIF
RETURN

PROCEDURE Ajustar
	Form_1.Grid_1.Width := ( Form_1.Width - Form_1.Grid_1.Col ) - (Form_1.Grid_1.Col+10)
	Form_1.Grid_1.Height:= ( Form_1.height- Form_1.Grid_1.Row ) - 70
RETURN

PROCEDURE FILTRO( oRs )
	form_1.grid_1.deleteallitems
	IF Form_1.Combo_1.Value = 1
		oRs:Filter:=""
	ELSE
		if len( form_1.text_1.value ) > 0
			oRs:Filter:=Form_1.combo_1.item(form_1.combo_1.value)+" LIKE '"+form_1.text_1.value+"%'"		
		else
			msgstop('Input condition for create filter')
			return
		endif
	ENDIF
	Form_1.Grid_1.Update	
RETURN

PROCEDURE Del()
	IF Msgyesno('Delete item')
		form_1.grid_1.delete( form_1.grid_1.value )
	ENDIF
RETURN
